// MiniSolution.cpp : Defines the entry point for the console application.
// 
// Ouais, bon, vite fait.
// Pas trs propre, mais a va en fait.
//
// Une premire partie sur l'interfaage,
// Une seconde partie sur l'algo en lui mme (la plus courte, comme toujours...) + affichage des rsultats

#include "stdafx.h"
#include <iostream>
#include <math.h>
#include <stdio.h>


using namespace std;


// Mes structures vite faites.
struct Point
{
	float x,y;
};

struct Route
{
	int d,f; // Dbut, Fin
	float l; // Longueur
};



int _tmain(int argc, _TCHAR* argv[])
{
	//##################################################################
	// Premire partie : interfaage, lecture dans le fichier...
	//##################################################################
	// Toggles
	bool bHelp;
	int i;
	bHelp = false;
	
	if(argc < 2)
		bHelp = true;
	
	for(i=2; i<argc; i++)
	{
		if(argv[i][0] == '-')
		{
			switch(argv[i][1])
			{
			case 'h':
				bHelp = true;
				break;
			default:
				break;
			}
		}
	}
	
	FILE *src;
	char szTmp[128];
	sprintf_s(szTmp, sizeof(szTmp), "%S", argv[1]);
	
	if(fopen_s(&src, szTmp, "rb"))
		bHelp = true;
	if(bHelp)
	{
		cout << "En paramtre le nom du fichier sur lequel on a droit d'accs... C'est tout pour l'instant\n";
		return 1;
	}
	
	int nPts; // Nombre de points
	int nRte; // Nombre de routes
	
	Point *pPts; // Tableau contenant les points
	Route *pRte; // Tableau contenant les routes
	
	// Bidouille pour passer du type WCHAR * au type CHAR * pour ouvrir le fichier
	memset(szTmp, 0, sizeof(szTmp));
	
	fgets(szTmp, sizeof(szTmp), src);
	sscanf_s(szTmp, "%u", &nPts);
	cout << "Lecture de " << nPts << " points.\n";
	pPts = new Point[nPts];
	for(i=0; i<nPts; i++)
	{
		fgets(szTmp, sizeof(szTmp), src);
		sscanf_s(szTmp, "%f\t%f", &pPts[i].x, &pPts[i].y);
		cout << pPts[i].x << " " << pPts[i].y << endl;
	}
	
	fgets(szTmp, sizeof(szTmp), src);
	sscanf_s(szTmp, "%u", &nRte);
	cout << "Lecture de " << nRte << " routes.\n";
	pRte = new Route[nRte];
	for(i=0; i<nRte; i++)
	{
		fgets(szTmp, sizeof(szTmp), src);
		sscanf_s(szTmp, "%u\t%u", &pRte[i].d, &pRte[i].f);
		pRte[i].l = sqrt( powf(pPts[pRte[i].d].x-pPts[pRte[i].f].x, 2.0f) + powf(pPts[pRte[i].d].y-pPts[pRte[i].f].y, 2.0f) );
		cout << pRte[i].d << "-" << pRte[i].f << "\tde longueur " << pRte[i].l << endl;
	}
	
	//##################################################################
	// Seconde partie : le code !
	//##################################################################
	// On a fait une lecture rapide de nos points et de nos routes.
	// Application  Floyd-Warshall
	// On va dfinir une matrice.
	// Vu que j'ai pas Internet sur mon lit, je sais pas comment on crit l'infini. Donc ce sera 1 million.
	
	float *fMat; // Matrice des distances entre les points. On la reprsente par un tableau d'une seule colonne (moins chiant)
	// Deviendra la matrice des cots des trajets : en (i,j), c'est le cot de i  j
	int *iMat; // Matrice des antcdents
	int j,k,l,n;
	
	fMat = new float[nPts*nPts];
	iMat = new int[nPts*nPts];
	// On initialise, on met les routes aprs
	for(i=0; i<nPts; i++)
	{
		for(j=0; j<nPts; j++)
		{
			fMat[i*nPts+j] = 1e6; // On suppose que 1e6 = 1000000 est proche de l'infini ;-)
			iMat[i*nPts+j] = i;
		}
		fMat[i*nPts+i] = 0.0f;
	}
	
	// On remplit avec les longueurs qu'il faut et les routes qu'il faut
	// On fait les routes  sens unique cette fois
	for(i=0; i<nRte; i++)
	{
		fMat[pRte[i].d*nPts+pRte[i].f] = pRte[i].l;
		//fMat[pRte[i].f*nPts+pRte[i].d] = pRte[i].l;
	}
	
	// On applique l'algo
	int indexIJ, indexIK, indexKJ;
	for(k=0; k<nPts; k++)
	{
		for(i=0; i<nPts; i++)
		{
			for(j=0; j<nPts; j++)
			{
				indexIJ = i*nPts+j;
				indexIK = i*nPts+k;
				indexKJ = k*nPts+j;
				if(fMat[indexIJ] > fMat[indexIK] + fMat[indexKJ])
				{
					// La route IK+KJ est plus courte!
					fMat[indexIJ] = fMat[indexIK] + fMat[indexKJ];
					
					// K qui est le nouvel antcdent de de J
					// Cette ligne est pas vidente  voir sans un bout de papier
					iMat[indexIJ] = iMat[indexKJ];
				}
			}
		}
	}
	
	// Affichage des rsultats.
	int *iRte;
	iRte = new int[nPts];
	cout << "\n\nRsultats :\n";
	// Matrice des cots
	for(i=0; i<nPts; i++)
	{
		/*for(j=0; j<i; j++)
			cout << "\t";//*/ // Elle n'est pas symtrique en fait
		for(j=0; j<nPts; j++)
			cout << fMat[i*nPts+j] << "\t";
		cout << "\n";
	}
	// Affichage des routes
	for(i=0; i<nPts; i++)
	{
		// On se place  l'arrive (j), et on remonte les antcdents jusqu' touver le point initial (i)
		for(j=0; j<nPts; j++)
		{
			cout << "De " << i << " vers " << j << " : ";
			k = j;
			
			if(k != i)
			{
				// Les routes sont  l'envers... Encore une petite manoeuvre
				for(n=nPts-1; k != i; n--, k=iMat[i*nPts+k])
					iRte[n] = k;
				
				cout << i << " ";
				for(n++; n<nPts; n++)
					cout << iRte[n] << " ";
			}
			cout << "\n";
		}
	}
	
	// Nettoyage !
	delete[] pPts;
	delete[] pRte;
	delete[] fMat;
	delete[] iMat;
	delete[] iRte;
	fclose(src);
	return 0;
}

